#!/bin/sh
# sciaganie listingu z ftp.
#porównanie z katalogiem lokalnym
#generowanie listy
#/tmp/letronik/newDir.txt
# plikow, ktorych brakuje na ftp.
#DIAGNOSYKA
#wyjscia  z programu do logu tymczasowego na /media/zeletronik/outlog.txtoutlog.txt
#czas do logow
dayhour=$(date +%Y.%m.%d-%H:%M);
#zapisywanie pliku kofiguracyjnego na ramdysk

#sprawdzanie ramdysku

mainlog="/opt/zeletronik/log/zeletronik.log" #glowny log awarii
loglong=500 #ilosc wierszy loga





#odczytywanie danych ftp z konfiguracji
echo "$dayhour; program indexFTP.sh" > /opt/zeletronik/ramdisk/outlog.txt ;
ftpAddress=$(grep ftpAddress /opt/zeletronik/ramdisk/leicMain.conf | cut -d= -f2 | sed 's/ //g');
echo "adres serwera FTP: $ftpAddress" >> /opt/zeletronik/ramdisk/outlog.txt;
if [ -z "$ftpAddress" ]
then
echo "$dayhour; STOP - brak adresu ftp  w konfiguracji leicMain.conf" >> "$mainlog"
#cp "$mainlog" /opt/zeletronik/radisk/tmplog
#tail -"$loglong" /media/zeletronik/tmplog > "$mainlog" 
exit 1
fi
ftpUser=$(grep ftpUser /opt/zeletronik/ramdisk/leicMain.conf | cut -d= -f2 | sed 's/ //g');
echo "FTP login: $ftpUser"  >> /opt/zeletronik/ramdisk/outlog.txt  ;
ftpDir=$(grep ftpDir /opt/zeletronik/ramdisk/leicMain.conf | cut -d= -f2 | sed 's/ //g');
echo "Katalog na serwerze FTP: $ftpDir" >> /opt/zeletronik/ramdisk/outlog.txt  ;
ftpPasswd=$(grep ftpPasswd /opt/zeletronik/ramdisk/leicMain.conf | cut -d= -f2 | sed 's/ //g');
echo "haslo FTP: tajne" >> /opt/zeletronik/ramdisk/outlog.txt  ;# +$ftpPasswd+;

#cd $logDir
#ls -l > /media/zeletronik/logglist.txt

#czytalie listingu z FTP
(
echo "user $ftpUser $ftpPasswd";
echo "cd $ftpDir";
echo "dir"
echo "bye";
) | ftp -n "$ftpAddress" > /opt/zeletronik/ramdisk/ftplist.txt
#czy jest listing z FTP?
tmp=$(grep 'Not connected' '/opt/zeletronik/ramdisk/ftplist.txt' )
if [ -n "$tmp" ]
then
echo "$dayhour; STOP - FTP nie zwrocil listingu - moze zle dane do logowania" >> "$mainlog"
#cp "$mainlog" /media/zeletronik/tmplog
#tail -"$loglong" /media/zeletronik/tmplog > "$mainlog" 
exit 1
fi


#tworzenie listy html

(
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
echo '<html lang="pl">';
echo '<head>';
echo   '<meta content="text/html; charset=UTF-8" http-equiv="content-type">';
 echo '<title>Lista raportów odwiedzalności</title>';
echo  '<meta content="Leszek Łoboda" name="author">';
echo '</head><body><h1>Lista raportów owiedzalności</h1><p>';
)> /opt/zeletronik/ramdisk/index.html

grep csv /opt/zeletronik/ramdisk/ftplist.txt > /opt/zeletronik/ramdisk/tmp
awk '{print "<a href=",$9,">",$9,"</a><br>"}' /opt/zeletronik/ramdisk/tmp >> /opt/zeletronik/ramdisk/index.html

echo '<br>Koniec listy<br></p></body></html>' >> /opt/zeletronik/ramdisk/index.html
#cat /media/zeletronik/index.html
#wysylanie listy na ftp
cd /opt/zeletronik/ramdisk/

(
echo "user $ftpUser $ftpPasswd";
echo "cd $ftpDir";
#poczatek czytania wykazu pliku.

echo 'put index.html';
echo "bye";
) | ftp -n $ftpAddress



